
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef OBJECT_TIMESTAMPS_H
#define OBJECT_TIMESTAMPS_H

class ObjLifeCycle;

// holds various object (entity) timestamps
class ObjTimes {
	friend class ObjLifeCycle;

	public:
		ObjTimes() { reset(); }

		void reset();

		Time lmt() const { return theLmt; }
		Time exp() const { return theExp; }
		bool showLmt() const { return doShowLmt; }
		bool knownExp() const { return theExp >= 0; }

	protected:
		Time theLmt;
		Time theExp;
		bool doShowLmt;
};

#endif
