
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "runtime/LogComment.h"
#include "RobotSym.h"
#include "runtime/ErrorMgr.h"
#include "AsyncClt.h"

AsyncClt::AsyncClt(RndDistr *aThinkDistr) {
	Assert(!theThinkDistr);
	Assert(aThinkDistr);
	theThinkDistr = aThinkDistr;
}

void AsyncClt::configure(const RobotSym *cfg, const NetAddr &aHost, bool bind2iface) {
	Assert(theThinkDistr);
	Client::configure(cfg, aHost, bind2iface);
}

void AsyncClt::wakeUp(const Alarm &a) {
	Client::wakeUp(a);
	scheduleLaunch(a.time()); // next

	if (theExtraLaunchLvl)
		--theExtraLaunchLvl;
	else
		tryLaunch(genXact());
}
