
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_POPULARITY_MODEL_CLASS_H
#define PG_POPULARITY_MODEL_CLASS_H

class RndGen;
class PopDistr;
class PopModelSym;

// popularity model

class PopModel {
	public:
		PopModel();

		void configure(const PopModelSym *cfg);

		// selects oid, adjusts for wss and hot set position
		int choose(RndGen &rng, int lastOid, int wsCap, int hotSetPos);

	protected:
		PopDistr *theDistr;
		double theHotSetProb;  // prob of selecting a hot object
		double theHotSetFrac;  // hot_set_size/wss
};

#endif
