
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_PRIVATE_WORLD_CLASS_H
#define PG_PRIVATE_WORLD_CLASS_H

#include "runtime/HotSet.h"

class OLog;
class ILog;

class PrivWorld {
	public:
		static int TheSharedWss; // all local private worlds

	public:
		PrivWorld();

		int lastObjName() const { return theObjCnt; }
		int wss() const { return theWss; }

		int nextObjName() { if (theWss < 0) ++TheSharedWss; return ++theObjCnt; }
		int hotSetPos() { return theHotSet.position(theObjCnt, theWss); }

		void freezeWss();

		void store(OLog &ol) const;
		void load(ILog &il);

	protected:
		HotSet theHotSet;
		int theObjCnt;
		int theWss;
};

inline
OLog &operator <<(OLog &ol, const PrivWorld &pw) {
	pw.store(ol);
	return ol;
}

inline
ILog &operator >>(ILog &il, PrivWorld &pw) {
	pw.load(il);
	return il;
}

#endif
