
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_ICP_XACTION_CLASS_H
#define PG_ICP_XACTION_CLASS_H

#include "NetAddr.h"
#include "base/ObjId.h"
#include "IcpOpCode.h"

// base class for ICP client and server xactions
class IcpXaction {
	public:
		IcpXaction() { reset(); }

		void reset();

		int logCat() const { return theLogCat; }
		const ObjId &oid() const { return theOid; }
		Time lifeTime() const { return theLifeTime; }
		Size repSize() const { return theRepSize; }

		bool hit() const { return theResult == icpHit; }
		bool timedout() const { return theResult == icpTimeout; }

	protected:
		void start();
		void finish(int errNo);

	protected:
		NetAddr theAddr;
		ObjId theOid;       // cached from theReason

		Time theStartTime;  // started doing something
		Time theLifeTime;   // [start, stop];

		Size theRepSize;

		IcpOpCode theResult;

		int theLogCat;
};

#endif
