
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_STAT_CYCLE_H
#define PG_STAT_CYCLE_H

#include "Array.h"
#include "StatIntvl.h"

class Notifier;
class StatCycleRec;

// StatIntvRec stats are reset and logged every [short] time interval

class StatCycle: public StatIntvl {
	public:
		StatCycle();
		virtual ~StatCycle();

		void period(Time aPeriod);
		void notifier(Notifier *aNotifier);

		void start();

		virtual void wakeUp(const Alarm &alarm);

	protected:
		virtual StatIntvlRec &getRec(int cat);
		virtual const StatIntvlRec &getRec(int cat) const;

		void nextIntvl(Time wakeUpTime);
		void restart();
		void report(const StatCycleRec &rec) const;

	protected:
		Array<StatCycleRec*> theRecs;
		Notifier *theNotifier;
		Time thePeriod;
};

#endif
