
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "xparser.h"

#include "String.h"
#include "SynSymTbl.h"


/* SynSymTblItem */

SynSymTblItem::SynSymTblItem(): theSym(0), theUseCnt(0) {
}

SynSymTblItem::SynSymTblItem(const String &aType, const String &aName):
	theSym(0), theName(aName), theType(aType), theUseCnt(0) {
}

SynSymTblItem::~SynSymTblItem() {
	delete theSym;
}



/* SynSymTbl */

SynSymTbl::SynSymTbl() {
}

SynSymTbl::~SynSymTbl() {
	for (int i = 0; i < count(); ++i)
		delete valAt(i);
}

void SynSymTbl::report(ostream &os, const String &pfx) const {

	for (int i = 0; i < count(); ++i) {
		if (valAt(i)) {
			os << pfx << valAt(i)->name() << " = ";
			if (valAt(i)->sym())
				valAt(i)->sym()->print(os, pfx);
			else
				os << "undef()";
			os << ';' << endl;
		}
	}
}
