
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef XPARSER_TOKEN_SYMBOL_H
#define XPARSER_TOKEN_SYMBOL_H

#include "SynSym.h"

// The TokenSym class maintains "token" attributes that
// store tokens as they come from a Lexer

class TokenSym : public SynSym {
	public:
		TokenSym(const String &n, int anId = -1);

		int id() const { return theId; }
		const String &spelling() const { return theSpell; }

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	private:
		String theSpell;
		int theId;
};

#endif
