
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef X_NET_DOUBLE_H
#define X_NET_DOUBLE_H

#include <sys/types.h>

/* BSD hton */
#include <sys/param.h>

/* IRIX hton */
#include <netinet/in.h>

/* Solaris hton */
#include <arpa/inet.h>


// binary, fpoint-representation-independent storage for doubles
class NetDouble {
	public:
		NetDouble(): mnt(0), exp(0) {}
		NetDouble(double x);     // extracts components 

		operator double() const; // merges components

		inline bool operator ==(const NetDouble &d);
		inline bool operator !=(const NetDouble &d);

	public:
		int mnt; // mantissa
		int exp; // exponent
};

inline
bool NetDouble::operator ==(const NetDouble &d) {
	return mnt == d.mnt && exp == d.exp;
}

inline
bool NetDouble::operator !=(const NetDouble &d) {
	return mnt != d.mnt || exp != d.exp;
}

#endif
